"
    Copyright (C) 2015-now Jan Vrany

    This code is not an open-source (yet). You may use this code
    for your own experiments and projects, given that:

    * all modification to the code will be sent to the
      original author for inclusion in future releases
    * this is not used in any commercial software

    This license is provisional and may (will) change in
    a future.
"
"{ Package: 'jv:llvm_s' }"

"{ NameSpace: Smalltalk }"

LLVMType subclass:#LLVMTypeVoid
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'LLVM-S-Core-Types'
!

!LLVMTypeVoid class methodsFor:'documentation'!

copyright
"
    Copyright (C) 2015-now Jan Vrany

    This code is not an open-source (yet). You may use this code
    for your own experiments and projects, given that:

    * all modification to the code will be sent to the
      original author for inclusion in future releases
    * this is not used in any commercial software

    This license is provisional and may (will) change in
    a future.
"
! !

!LLVMTypeVoid methodsFor:'accessing'!

sizeInBits
    "For integer, pointer, FP  types, return the size in bits. For all 
     other types, throw an LLVMTypeError.

     LLVMType int32 sizeInBits -> 32
     LLVMType int1 sizeInBits  -> 1
    "
    ^ 0

    "Created: / 12-10-2015 / 18:27:10 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!LLVMTypeVoid methodsFor:'converting'!

array: numberOfElements
    "Create a fixed-size array whose elements are of type of receiver
     `LLVMType int8 array: 13` returns `[ 13 x i8 ]`"

    self shouldNotImplement

    "Created: / 12-10-2015 / 18:28:05 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

pointer
    "Return a pointer to the type represented by the receiver.
     `LLVMType int32 pointer` returns int32_t*"

    self shouldNotImplement

    "Created: / 12-10-2015 / 18:27:44 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!LLVMTypeVoid methodsFor:'testing'!

isVoidType
    ^true

    "Created: / 13-08-2015 / 16:52:36 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

